/*
 * TeleStax, Open Source Cloud Communications  Copyright 2012.
 * and individual contributors
 * by the @authors tag. See the copyright.txt in the distribution for a
 * full listing of individual contributors.
 *
 * This is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation; either version 2.1 of
 * the License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this software; if not, write to the Free
 * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA, or see the FSF site: http://www.fsf.org.
 */
package org.mobicents.protocols.ss7.map.service.callhandling;

import org.mobicents.protocols.ss7.map.api.service.callhandling.CallDiversionTreatmentIndicator;
import org.mobicents.protocols.ss7.map.api.service.callhandling.CallDiversionTreatmentIndicatorValue;
import org.mobicents.protocols.ss7.map.primitives.OctetStringLength1Base;

/**
 * 
 * @author Lasith Waruna Perera
 * 
 */
public class CallDiversionTreatmentIndicatorImpl extends OctetStringLength1Base  implements CallDiversionTreatmentIndicator{

	public CallDiversionTreatmentIndicatorImpl() {
		super("CallDiversionTreatmentIndicator");
	}
	
	public CallDiversionTreatmentIndicatorImpl(int data) {
		super("CallDiversionTreatmentIndicator", data);
	}
	
	public CallDiversionTreatmentIndicatorImpl(CallDiversionTreatmentIndicatorValue value) {
		super("CallDiversionTreatmentIndicator", value != null ? value.getCode() : 0);
	}

	@Override
	public int getData() {
		return data;
	}

	@Override
	public CallDiversionTreatmentIndicatorValue getCallDiversionTreatmentIndicatorValue() {
		return CallDiversionTreatmentIndicatorValue.getInstance(this.data);
	}
	
	@Override
	public String toString() {
		StringBuilder sb = new StringBuilder();
		sb.append(this._PrimitiveName);
		sb.append(" [");

		sb.append("Value=");
		sb.append(this.getCallDiversionTreatmentIndicatorValue());

		sb.append(", Data=");
		sb.append(this.data);

		sb.append("]");

		return sb.toString();
	}

}
