/*
 * TeleStax, Open Source Cloud Communications  Copyright 2012.
 * and individual contributors
 * by the @authors tag. See the copyright.txt in the distribution for a
 * full listing of individual contributors.
 *
 * This is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation; either version 2.1 of
 * the License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this software; if not, write to the Free
 * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA, or see the FSF site: http://www.fsf.org.
 */
package org.mobicents.protocols.ss7.map.service.mobility.subscriberManagement;

import org.mobicents.protocols.ss7.map.api.service.mobility.subscriberManagement.CauseValue;
import org.mobicents.protocols.ss7.map.api.service.mobility.subscriberManagement.CauseValueCodeValue;
import org.mobicents.protocols.ss7.map.primitives.OctetStringLength1Base;

/**
 * 
 * @author Lasith Waruna Perera
 * 
 */
public class CauseValueImpl extends OctetStringLength1Base implements CauseValue {
	
	public CauseValueImpl() {
		super("CauseValue");
	}

	public CauseValueImpl(int data) {
		super("CauseValue", data);
	}
	
	public CauseValueImpl(CauseValueCodeValue value) {
		super("CauseValue", value != null ? value.getCode() : 0);
	}

	@Override
	public CauseValueCodeValue getCauseValueCodeValue() {
		return CauseValueCodeValue.getInstance(this.data);
	}
	
	@Override
	public int getData() {
		return data;
	}
	
	@Override
	public String toString() {
		StringBuilder sb = new StringBuilder();
		sb.append(this._PrimitiveName);
		sb.append(" [");
		
		sb.append("Value=");
		sb.append(this.getCauseValueCodeValue());

		sb.append(", Data=");
		sb.append(this.data);

		sb.append("]");

		return sb.toString();
	}

}
